import { ResourceProps } from 'aws-cdk-lib';
import { ManagedRule, MaximumExecutionFrequency } from 'aws-cdk-lib/aws-config';
import { ManagedPolicy, Role } from 'aws-cdk-lib/aws-iam';
import { IConstruct } from 'constructs';
import { RemediationConfiguration } from '../config/remediation-configuration';
export interface IamPasswordPolicyProps extends ResourceProps {
    readonly autoRemediation?: boolean;
    readonly configRuleName?: string;
    readonly description?: string;
    readonly maxPasswordAge?: number;
    readonly maximumExecutionFrequency?: MaximumExecutionFrequency;
    readonly minimumPasswordLength?: number;
    readonly passwordReusePrevention?: number;
    readonly requireLowercaseCharacters?: boolean;
    readonly requireNumbers?: boolean;
    readonly requireSymbols?: boolean;
    readonly requireUppercaseCharacters?: boolean;
}
export declare class IamPasswordPolicy extends ManagedRule {
    static readonly DEFAULT_DESCRIPTION: string;
    static readonly DEFAULT_MAX_PASSWORD_AGE: number;
    static readonly DEFAULT_MINIMUM_PASSWORD_LENGTH: number;
    static readonly DEFAULT_PASSWORD_REUSE_PREVENTION: number;
    static readonly DEFAULT_REQUIRE_LOWERCASE_CHARACTERS: boolean;
    static readonly DEFAULT_REQUIRE_NUMBERS: boolean;
    static readonly DEFAULT_REQUIRE_SYMBOLS: boolean;
    static readonly DEFAULT_REQUIRE_UPPERCASE_CHARACTERS: boolean;
    static readonly MANAGED_RULE_NAME: string;
    static readonly REMEDIATION_DOCUMENT_NAME: string;
    readonly maxPasswordAge: number;
    readonly minimumPasswordLength: number;
    readonly passwordReusePrevention: number;
    readonly requireLowercaseCharacters: boolean;
    readonly requireNumbers: boolean;
    readonly requireSymbols: boolean;
    readonly requireUppercaseCharacters: boolean;
    readonly remediationConfiguration: RemediationConfiguration;
    readonly remediationPolicy: ManagedPolicy;
    readonly remediationRole: Role;
    constructor(scope: IConstruct, id: string, props: IamPasswordPolicyProps);
}
