import { ResourceProps } from 'aws-cdk-lib';
import { ManagedRule, MaximumExecutionFrequency } from 'aws-cdk-lib/aws-config';
import { ManagedPolicy, Role } from 'aws-cdk-lib/aws-iam';
import { IConstruct } from 'constructs';
import { RemediationConfiguration } from '../config/remediation-configuration';
export interface VpcDefaultSecurityGroupClosedProps extends ResourceProps {
    readonly autoRemediation?: boolean;
    readonly configRuleName?: string;
    readonly description?: string;
    readonly maximumExecutionFrequency?: MaximumExecutionFrequency;
}
export declare class VpcDefaultSecurityGroupClosed extends ManagedRule {
    static readonly DEFAULT_DESCRIPTION: string;
    static readonly MANAGED_RULE_NAME: string;
    static readonly REMEDIATION_DOCUMENT_NAME: string;
    readonly remediationConfiguration: RemediationConfiguration;
    readonly remediationPolicy: ManagedPolicy;
    readonly remediationRole: Role;
    constructor(scope: IConstruct, id: string, props: VpcDefaultSecurityGroupClosedProps);
}
