import { CfnRemediationConfiguration } from 'aws-cdk-lib/aws-config';
import { IConstruct } from 'constructs';
import { IAutomationDocument } from '../../ssm';
export declare class RemediationTargetType {
    static readonly SSM_DOCUMENT: RemediationTargetType;
    static of(value: string): RemediationTargetType;
    readonly value: string;
    private constructor();
}
export interface RemediationTargetConfiguration {
    readonly controls?: CfnRemediationConfiguration.ExecutionControlsProperty;
    readonly targetId: string;
    readonly targetType: RemediationTargetType;
    readonly targetVersion?: string;
}
export interface IRemediationTarget {
    bind(scope: IConstruct): RemediationTargetConfiguration;
}
export interface AutomationDocumentRemediationProps {
    readonly concurrencyPercentage?: number;
    readonly document: IAutomationDocument;
    readonly errorPercentage?: number;
    readonly version?: string;
}
export declare class RemediationTarget {
    static automationDocument(props: AutomationDocumentRemediationProps): IRemediationTarget;
}
