import { ArnFormat, Resource, ResourceProps } from 'aws-cdk-lib';
import { CfnHub } from 'aws-cdk-lib/aws-securityhub';
import { IConstruct } from 'constructs';
export declare class ControlFindingGenerator {
    static readonly SECURITY_CONTROL: ControlFindingGenerator;
    static readonly STANDARD_CONTROL: ControlFindingGenerator;
    static of(value: string): ControlFindingGenerator;
    readonly value: string;
    private constructor();
}
export interface IHub {
    readonly hubArn: string;
    readonly hubName: string;
}
declare abstract class HubBase extends Resource implements IHub {
    abstract readonly hubArn: string;
    abstract readonly hubName: string;
}
export interface HubProps extends ResourceProps {
    readonly autoEnableControls?: boolean;
    readonly consolidatedFindings?: boolean;
    readonly enableDefaultStandards?: boolean;
}
export interface HubAttributes {
    readonly arn?: string;
    readonly name?: string;
}
export declare class Hub extends HubBase {
    static readonly ARN_FORMAT: ArnFormat;
    static fromHubArn(scope: IConstruct, id: string, arn: string): IHub;
    static fromHubAttributes(scope: IConstruct, id: string, attrs: HubAttributes): IHub;
    static fromHubName(scope: IConstruct, id: string, name: string): IHub;
    readonly autoEnableControls?: boolean;
    readonly consolidatedFindings?: boolean;
    readonly controlFindingGenerator?: ControlFindingGenerator;
    readonly enableDefaultStandards?: boolean;
    readonly resource: CfnHub;
    readonly hubArn: string;
    readonly hubName: string;
    constructor(scope: IConstruct, id: string, props?: HubProps);
}
export {};
