import { IConstruct } from 'constructs';
import { DocumentBase, IDocument } from './document-base';
export declare class AutomationSchemaVersion {
    static readonly VER_0_3: AutomationSchemaVersion;
    static of(version: string): AutomationSchemaVersion;
    readonly version: string;
    private constructor();
}
export interface IAutomationDocument extends IDocument {
    readonly automationDefinitionArn: string;
    arnForAutomationDefinitionVersion(version: string): string;
}
export declare class AutomationDocument extends DocumentBase implements IAutomationDocument {
    static readonly DEFAULT_SCHEMA_VERSION: AutomationSchemaVersion;
    static fromManaged(scope: IConstruct, id: string, managedDocumentName: string): IAutomationDocument;
    readonly automationDefinitionArn: string;
    private constructor();
    arnForAutomationDefinitionVersion(version: string): string;
}
