import { IConstruct } from 'constructs';
import { DocumentFormat } from './document-format';
export interface DocumentContentResult {
    readonly content: string;
    readonly documentFormat: DocumentFormat;
}
export interface IDocumentContent {
    bind(scope: IConstruct): DocumentContentResult;
}
export interface ObjectContentProps {
    readonly input: {
        [key: string]: any;
    };
}
export interface StringContentProps {
    readonly content: string;
    readonly documentFormat: DocumentFormat;
}
export declare class DocumentContent {
    static fromObject(props: ObjectContentProps): IDocumentContent;
    static fromString(props: StringContentProps): IDocumentContent;
}
